# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/07_deeplmt.ipynb.

# %% auto 0
__all__ = ['deepltranslate']

# %% ../nbs/07_deeplmt.ipynb 8
import os
import deepl
from pathlib import Path

class deepltranslate:
    """Class to get translations from the DeepL API"""
    def __init__(self):
        """Constructor of deepltranslate class"""
        self._apikey = os.getenv('DEEPL_API_KEY')
        self._translator = deepl.Translator(self._apikey)

    def translate_text(self,sourcelang, targetlang, text):
        """Function to translate text into the target language"""
        source_langid_upper = sourcelang.upper()
        target_langid_upper = targetlang.upper()

        result = self._translator.translate_text(text,source_lang=source_langid_upper,target_lang=target_langid_upper,split_sentences='off')

        return result.text

    def check_langpair(self,sourcelang, targetlang):
        """Function to check if the language pair is supported"""
        source_langid_upper = sourcelang.upper()
        target_langid_upper = targetlang.upper()
        supported_source_languages = [lang.code for lang in self._translator.get_source_languages()]
        supported_target_languages = [lang.code for lang in self._translator.get_target_languages()]
        
        if source_langid_upper in supported_source_languages:
            if target_langid_upper in supported_target_languages:
                return True
        
        return False
